-- # first Query

create table chunkidefntifers as
select project.name as projectname, project.htmlurl, project.main_project_id as project_id,conflictingchunk.developerdecision,solutioncontent.content,
(coalesce(conflictingchunk.separatorline, 0) - coalesce(conflictingchunk.beginline, 0)) as LengthV1,
          (coalesce(conflictingchunk.endline, 0) - coalesce(conflictingchunk.separatorline, 0))as LengthV2,
(coalesce(conflictingchunk.endline, 0) - coalesce(conflictingchunk.beginline, 0)) as size_of_chunk,
       revision.sha,revision.id as revision_id,revision.numberconflictingfiles,revision.basesha,revision.leftsha,revision.rightsha,
       conflictingfile.path,conflictingfile.name,conflictingfile.filetype


from project, conflictingchunk,solutioncontent,revision,conflictingfile

where  revision.project_id = project.id and  not fork and analyzed and solutioncontent.conflictingchunk_id = conflictingchunk.id and conflictingfile.revision_id = revision.id and conflictingchunk.conflictingfile_id = conflictingfile.id
and project.main_project_id in (select distinct Merge_Conflicts_Projects.project_id from final_seclected_peojcets)




-- # Second Query

create table With_number_of_conflictingchunks_for_each_conflict_chunk as

select public.project.name,
 public.revision.project_id,
 public.revision.sha, public.revision.id as revision_id,
 COUNT ( public.revision.sha) as count, revision.numberconflictingfiles
from public.project, public.revision, public.conflictingfile, public.conflictingchunk
WHERE project.id = revision.project_id AND
 public.revision.id = conflictingfile.revision_id AND
 public.conflictingfile.id = public.conflictingchunk.conflictingfile_id
   AND  project.numberconflictingmerges =3355
--  and revision.sha like '252b36379fedd0c91125679170a56d080d05ae9f'
GROUP BY public.project.name, public.revision.project_id, public.revision.sha,public.revision.id,revision.numberconflictingfiles





-- # ThirdQuery


create table merge_conflict_dataset as
select chunkidefntifers.htmlurl, chunkidefntifers.name as filename,chunkidefntifers.project_id,chunkidefntifers.projectname , chunkidefntifers.lengthv1,chunkidefntifers.lengthv2,chunkidefntifers.size_of_chunk, chunkidefntifers.sha,chunkidefntifers.numberconflictingfiles,chunkidefntifers.developerdecision,
chunkidefntifers.filetype,chunkidefntifers.basesha,chunkidefntifers.leftsha,chunkidefntifers.rightsha,chunkidefntifers.revision_id,chunkidefntifers.content,
      With_number_of_conflictingchunks_for_each_conflict_chunk.count as number_of_conflicting_chunks
from  chunkidefntifers,With_number_of_conflictingchunks_for_each_conflict_chunk where  chunkidefntifers.revision_id=With_number_of_conflictingchunks_for_each_conflict_chunk.revision_id


-- # Forth Query , I add some columns to extract the extra data from our projects ( 1/ date_time for the resolution 2/ date_time for local  3/ date_time for remote  4/ # of commits in local 5/ # of commits in Remote 6/ Number of Commits by The Owner of Local 7/ Number of Commits by The Owner of Remote 8/Number of Commits by The Resolver of Conflict

ALTER TABLE merge_conflict_dataset
ADD COLUMN date_time_for_the_resolution timestamptz;
ADD COLUMN date_time_for_the_local  timestamptz;
ADD COLUMN date_time_for_the_remote  timestamptz;
ADD COLUMN number_commits_local int;
ADD COLUMN number_commits_remote int;
ADD COLUMN number_commits_owner_local int;
ADD COLUMN number_commits_owner_remot int;
ADD COLUMN number_commits_owner_resolver int;

